package net.scott.minecraftvillagerdimensionmod;

import net.fabricmc.fabric.api.datagen.v1.DataGeneratorEntrypoint;
import net.fabricmc.fabric.api.datagen.v1.FabricDataGenerator;
import net.minecraft.class_7877;
import net.minecraft.class_7924;
import net.scott.minecraftvillagerdimensionmod.datagen.*;
import net.scott.minecraftvillagerdimensionmod.world.ModConfiguredFeatures;
import net.scott.minecraftvillagerdimensionmod.world.ModPlacedFeatures;
import net.scott.minecraftvillagerdimensionmod.world.biome.ModBiomes;
import net.scott.minecraftvillagerdimensionmod.world.dimension.ModDimensions;

public class MinecraftVillagerDimensionModDataGenerator implements DataGeneratorEntrypoint {
	@Override
	public void onInitializeDataGenerator(FabricDataGenerator fabricDataGenerator) {
		FabricDataGenerator.Pack pack = fabricDataGenerator.createPack();
		pack.addProvider(ModWorldGenerator::new);
		pack.addProvider(ModBlockTagProvider::new);
		pack.addProvider(ModItemTagProvider::new);
		pack.addProvider(ModLootTableProvider::new);
		pack.addProvider(ModModelProvider::new);
		pack.addProvider(ModRecipeProvider::new);
		pack.addProvider(ModAdvancementsProvider::new);
	}

	@Override
	public void buildRegistry(class_7877 registryBuilder){
		registryBuilder.method_46777(class_7924.field_41241, ModDimensions::bootstrapType);
		registryBuilder.method_46777(class_7924.field_41239, ModConfiguredFeatures::bootstrap);
		registryBuilder.method_46777(class_7924.field_41245, ModPlacedFeatures::bootstrap);
		registryBuilder.method_46777(class_7924.field_41236, ModBiomes::bootstrap);
	}
}
