package net.scott.minecraftvillagerdimensionmod.datagen;
// ... (Previous imports)
import net.fabricmc.fabric.api.datagen.v1.DataGeneratorEntrypoint;
import net.fabricmc.fabric.api.datagen.v1.FabricDataGenerator;
import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.datagen.v1.JsonKeySortOrderCallback;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricAdvancementProvider;
import net.minecraft.advancement.criterion.*;
import net.minecraft.class_161;
import net.minecraft.class_189;
import net.minecraft.class_1999;
import net.minecraft.class_2048;
import net.minecraft.class_2066;
import net.minecraft.class_2080;
import net.minecraft.class_2561;
import net.minecraft.class_2960;
import net.minecraft.class_7225;
import net.minecraft.class_8779;
import net.scott.minecraftvillagerdimensionmod.MinecraftVillagerDimensionMod;
import net.scott.minecraftvillagerdimensionmod.block.ModBlocks;
import net.scott.minecraftvillagerdimensionmod.entity.ModEntities;
import net.scott.minecraftvillagerdimensionmod.entity.custom.EvilVillagerBossEntity;
import net.scott.minecraftvillagerdimensionmod.item.ModItems;
import net.scott.minecraftvillagerdimensionmod.world.dimension.ModDimensions;

import java.util.concurrent.CompletableFuture;
import java.util.function.Consumer;

public class ModAdvancementsProvider extends FabricAdvancementProvider {

    public ModAdvancementsProvider(FabricDataOutput output, CompletableFuture<class_7225.class_7874> registryLookup) {
        super(output, registryLookup);
    }
    //ADVANCEMENT ORDER
    // ROOT: entered_dimension
    // - a_dark_wood
    //      + pillagerite_ingot
    //          - armor
    //          - tools
    //          - sword
    // - feeling_grey
    //      + magicite_dust
    //          - armor
    //          - tools
    //          - sword
    // - youre_syc
    //      + ancient_gemstone_dust
    //          - armor
    //          - tools
    //          - sword

    @Override
    public void generateAdvancement(class_7225.class_7874 id, Consumer<class_8779> consumer) {
        class_8779 enterDimensionAdvancement = class_161.class_162.method_707()
                .method_697(
                        ModItems.EMERALD_TORCH_ITEM, // Display icon, such as a custom item used to light the portal
                        class_2561.method_43470("Into the Unknown"), // Title
                        class_2561.method_43470("Enter the villager dimension."), // Description
                        class_2960.method_60654("textures/gui/advancements/backgrounds/end.png"), // You can customize the background image
                        class_189.field_1249, // Frame type
                        true, // Show toast
                        true, // Announce to chat
                        false // Hidden in the advancement tab
                )
                .method_705("entered_dimension", class_1999.class_2001.method_8799(ModDimensions.DIMW_LEVEL_KEY)) // Detect entering the custom dimension
                .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/enter_dimension");

        class_8779 rootAdvancementRowan = class_161.class_162.method_707()
                .method_701(enterDimensionAdvancement)
                .method_697(
                            ModBlocks.ROWAN_LOG, // The display icon
                            class_2561.method_43470("A Dark Wood"), // The title
                            class_2561.method_43470("Conquer the Rowans!"), // The description
                            class_2960.method_60654("textures/gui/advancements/backgrounds/adventure.png"), // Background image used
                            class_189.field_1254, // Options: TASK, CHALLENGE, GOAL
                            true, // Show toast top right
                            true, // Announce to chat
                            false // Hidden in the advancement tab
                    )
                    // The first string used in criterion is the name referenced by other advancements when they want to have 'requirements'
                    .method_705("a_dark_wood", class_2066.class_2068.method_8959(ModBlocks.ROWAN_LOG))
                    .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/rowan_advancement");

        class_8779 rootAdvancementJuniper = class_161.class_162.method_707()
                .method_701(enterDimensionAdvancement)
                .method_697(
                        ModBlocks.JUNIPER_LOG, // The display icon
                        class_2561.method_43470("Feeling Grey"), // The title
                        class_2561.method_43470("Are we on the west coast?"), // The description
                        class_2960.method_60654("textures/gui/advancements/backgrounds/adventure.png"), // Background image used
                        class_189.field_1254, // Options: TASK, CHALLENGE, GOAL
                        true, // Show toast top right
                        true, // Announce to chat
                        false // Hidden in the advancement tab
                )
                // The first string used in criterion is the name referenced by other advancements when they want to have 'requirements'
                .method_705("feeling_grey", class_2066.class_2068.method_8959(ModBlocks.JUNIPER_LOG))
                .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/juniper_advancement");

        class_8779 rootAdvancementSycamore = class_161.class_162.method_707()
                .method_701(enterDimensionAdvancement)
                .method_697(
                        ModBlocks.SYCAMORE_LOG, // The display icon
                        class_2561.method_43470("You're Syc!"), // The title
                        class_2561.method_43470("Why would you cut such a beautiful tree?"), // The description
                        class_2960.method_60654("textures/gui/advancements/backgrounds/adventure.png"), // Background image used
                        class_189.field_1254, // Options: TASK, CHALLENGE, GOAL
                        true, // Show toast top right
                        true, // Announce to chat
                        false // Hidden in the advancement tab
                )
                // The first string used in criterion is the name referenced by other advancements when they want to have 'requirements'
                .method_705("youre_syc", class_2066.class_2068.method_8959(ModBlocks.SYCAMORE_LOG))
                .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/sycamore_advancement");

        // Advancement for obtaining magicite_dust
        class_8779 magiciteDustAdvancement = class_161.class_162.method_707()
                .method_701(rootAdvancementJuniper)
                .method_697(
                        ModItems.MAGICITE_DUST,
                        class_2561.method_43470("Magic in the Air"),
                        class_2561.method_43470("Obtain Magicite Dust."),
                        class_2960.method_60654("textures/gui/advancements/backgrounds/adventure.png"),
                        class_189.field_1254,
                        true,
                        true,
                        false
                )
                .method_705("magicite_dust", class_2066.class_2068.method_8959(ModItems.MAGICITE_DUST)) // Criterion: obtain magicite dust
                .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/magicite_dust_advancement");

        // Advancements for Magicite Armor Set
        class_8779 magiciteArmorAdvancement = class_161.class_162.method_707()
                .method_701(magiciteDustAdvancement)
                .method_697(
                        ModItems.MAGICITE_HELMET,
                        class_2561.method_43470("Magicite Armor"),
                        class_2561.method_43470("Craft Magicite Armor"),
                        class_2960.method_60654("textures/gui/advancements/backgrounds/adventure.png"),
                        class_189.field_1254,
                        true,
                        true,
                        true
                )
                .method_705("magicite_helmet", class_2066.class_2068.method_8959(ModItems.MAGICITE_HELMET))
                .method_705("magicite_chestplate", class_2066.class_2068.method_8959(ModItems.MAGICITE_CHESTPLATE))
                .method_705("magicite_leggings", class_2066.class_2068.method_8959(ModItems.MAGICITE_LEGGINGS))
                .method_705("magicite_boots", class_2066.class_2068.method_8959(ModItems.MAGICITE_BOOTS))
                .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/magicite_armor");

        // Advancements for Magicite Tools Set
        class_8779 magiciteToolsAdvancement = class_161.class_162.method_707()
                .method_701(magiciteDustAdvancement)
                .method_697(
                        ModItems.MAGICITE_PICKAXE,
                        class_2561.method_43470("Magicite Tools"),
                        class_2561.method_43470("Craft Magicite Tools"),
                        class_2960.method_60654("textures/gui/advancements/backgrounds/adventure.png"),
                        class_189.field_1254,
                        true,
                        true,
                        true
                )
                .method_705("magicite_shovel", class_2066.class_2068.method_8959(ModItems.MAGICITE_SHOVEL))
                .method_705("magicite_pickaxe", class_2066.class_2068.method_8959(ModItems.MAGICITE_PICKAXE))
                .method_705("magicite_axe", class_2066.class_2068.method_8959(ModItems.MAGICITE_AXE))
                .method_705("magicite_hoe", class_2066.class_2068.method_8959(ModItems.MAGICITE_HOE))
                .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/magicite_tools");

        // Advancements for Magicite weapon
        class_8779 magiciteWeaponAdvancement = class_161.class_162.method_707()
                .method_701(magiciteDustAdvancement)
                .method_697(
                        ModItems.MAGICITE_SWORD,
                        class_2561.method_43470("Sword of Magic"),
                        class_2561.method_43470("Craft a Magicite Sword"),
                        class_2960.method_60654("textures/gui/advancements/backgrounds/adventure.png"),
                        class_189.field_1254,
                        true,
                        true,
                        true
                )
                .method_705("magicite_sword", class_2066.class_2068.method_8959(ModItems.MAGICITE_SWORD))
                .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/magicite_weapon");




        // Advancement for obtaining pillagerite_ingot
        class_8779 pillageriteIngotAdvancement = class_161.class_162.method_707()
                .method_701(rootAdvancementRowan)
                .method_697(
                        ModItems.PILLAGERITE_INGOT,
                        class_2561.method_43470("Pillager's Reward"),
                        class_2561.method_43470("Obtain a Pillagerite Ingot."),
                        class_2960.method_60654("textures/gui/advancements/backgrounds/adventure.png"),
                        class_189.field_1254,
                        true,
                        true,
                        false
                )
                .method_705("pillagerite_ingot", class_2066.class_2068.method_8959(ModItems.PILLAGERITE_INGOT)) // Criterion: obtain pillagerite ingot
                .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/pillagerite_ingot_advancement");

        // Advancements for Pillagerite Armor Set
        class_8779 pillageriteArmorAdvancement = class_161.class_162.method_707()
                .method_701(pillageriteIngotAdvancement)
                .method_697(
                        ModItems.PILLAGERITE_HELMET,
                        class_2561.method_43470("Powerful Dark Armor"),
                        class_2561.method_43470("Craft Pillagerite Armor"),
                        class_2960.method_60654("textures/gui/advancements/backgrounds/adventure.png"),
                        class_189.field_1254,
                        true,
                        true,
                        true
                )
                .method_705("pillagerite_chest", class_2066.class_2068.method_8959(ModItems.PILLAGERITE_HELMET))
                .method_705("pillagerite_helmet", class_2066.class_2068.method_8959(ModItems.PILLAGERITE_CHESTPLATE))
                .method_705("pillagerite_leggings", class_2066.class_2068.method_8959(ModItems.PILLAGERITE_LEGGINGS))
                .method_705("pillagerite_boots", class_2066.class_2068.method_8959(ModItems.PILLAGERITE_BOOTS))
                .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/pillagerite_armor");

        // Advancements for Pillagerite Tools Set
        class_8779 pillageriteToolsAdvancement = class_161.class_162.method_707()
                .method_701(pillageriteIngotAdvancement)
                .method_697(
                        ModItems.PILLAGERITE_PICKAXE,
                        class_2561.method_43470("Powerful Dark Tools"),
                        class_2561.method_43470("Craft the dark tools armor"),
                        class_2960.method_60654("textures/gui/advancements/backgrounds/adventure.png"),
                        class_189.field_1254,
                        true,
                        true,
                        true
                )
                .method_705("pillagerite_shovel", class_2066.class_2068.method_8959(ModItems.PILLAGERITE_SHOVEL))
                .method_705("pillagerite_pickaxe", class_2066.class_2068.method_8959(ModItems.PILLAGERITE_PICKAXE))
                .method_705("pillagerite_axe", class_2066.class_2068.method_8959(ModItems.PILLAGERITE_AXE))
                .method_705("pillagerite_hoe", class_2066.class_2068.method_8959(ModItems.PILLAGERITE_HOE))
                .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/pillagerite_tools");

        // Advancements for Pillagerite weapon
        class_8779 pillageriteWeaponAdvancement = class_161.class_162.method_707()
                .method_701(pillageriteIngotAdvancement)
                .method_697(
                        ModItems.PILLAGERITE_SWORD,
                        class_2561.method_43470("Sword of Darkness"),
                        class_2561.method_43470("Craft a pillagerite sword"),
                        class_2960.method_60654("textures/gui/advancements/backgrounds/adventure.png"),
                        class_189.field_1254,
                        true,
                        true,
                        true
                )
                .method_705("pillagerite_sword", class_2066.class_2068.method_8959(ModItems.PILLAGERITE_SWORD))
                .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/pillagerite_weapon");


        // Advancement for obtaining ancient_gemstone_dust
        class_8779 ancientGemstoneDustAdvancement = class_161.class_162.method_707()
                .method_701(rootAdvancementSycamore)
                .method_697(
                        ModItems.ANCIENT_GEMSTONE_DUST,
                        class_2561.method_43470("Ancient Secrets"),
                        class_2561.method_43470("Obtain Ancient Gemstone Dust."),
                        class_2960.method_60654("textures/gui/advancements/backgrounds/adventure.png"),
                        class_189.field_1254,
                        true,
                        true,
                        false
                )
                .method_705("ancient_gemstone_dust", class_2066.class_2068.method_8959(ModItems.ANCIENT_GEMSTONE_DUST)) // Criterion: obtain ancient gemstone dust
                .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/ancient_gemstone_dust_advancement");

        // Advancements for Ancient Gemstone Armor Set
        class_8779 ancientGemstoneArmorAdvancement = class_161.class_162.method_707()
                .method_701(ancientGemstoneDustAdvancement)
                .method_697(
                        ModItems.ANCIENT_GEMSTONE_HELMET,
                        class_2561.method_43470("Ancient Gemstone Armor"),
                        class_2561.method_43470("Craft Ancient Gemstone Armor"),
                        class_2960.method_60654("textures/gui/advancements/backgrounds/adventure.png"),
                        class_189.field_1254,
                        true,
                        true,
                        true
                )
                .method_705("ancient_gemstone_helmet", class_2066.class_2068.method_8959(ModItems.ANCIENT_GEMSTONE_HELMET))
                .method_705("ancient_gemstone_chestplate", class_2066.class_2068.method_8959(ModItems.ANCIENT_GEMSTONE_CHESTPLATE))
                .method_705("ancient_gemstone_leggings", class_2066.class_2068.method_8959(ModItems.ANCIENT_GEMSTONE_LEGGINGS))
                .method_705("ancient_gemstone_boots", class_2066.class_2068.method_8959(ModItems.ANCIENT_GEMSTONE_BOOTS))
                .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/ancient_gemstone_armor");

        // Advancements for Ancient Gemstone Tools Set
        class_8779 ancientGemstoneToolsAdvancement = class_161.class_162.method_707()
                .method_701(ancientGemstoneDustAdvancement)
                .method_697(
                        ModItems.ANCIENT_GEMSTONE_PICKAXE,
                        class_2561.method_43470("Ancient Gemstone Tools"),
                        class_2561.method_43470("Craft Ancient Gemstone Tools"),
                        class_2960.method_60654("textures/gui/advancements/backgrounds/adventure.png"),
                        class_189.field_1254,
                        true,
                        true,
                        true
                )
                .method_705("ancient_gemstone_shovel", class_2066.class_2068.method_8959(ModItems.ANCIENT_GEMSTONE_SHOVEL))
                .method_705("ancient_gemstone_pickaxe", class_2066.class_2068.method_8959(ModItems.ANCIENT_GEMSTONE_PICKAXE))
                .method_705("ancient_gemstone_axe", class_2066.class_2068.method_8959(ModItems.ANCIENT_GEMSTONE_AXE))
                .method_705("ancient_gemstone_hoe", class_2066.class_2068.method_8959(ModItems.ANCIENT_GEMSTONE_HOE))
                .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/ancient_gemstone_tools");

        // Advancements for Ancient Gemstone weapon
        class_8779 ancientGemstoneWeaponAdvancement = class_161.class_162.method_707()
                .method_701(ancientGemstoneDustAdvancement)
                .method_697(
                        ModItems.ANCIENT_GEMSTONE_SWORD,
                        class_2561.method_43470("Sword of the Ancients"),
                        class_2561.method_43470("Craft an Ancient Gemstone Sword"),
                        class_2960.method_60654("textures/gui/advancements/backgrounds/adventure.png"),
                        class_189.field_1254,
                        true,
                        true,
                        true
                )
                .method_705("ancient_gemstone_sword", class_2066.class_2068.method_8959(ModItems.ANCIENT_GEMSTONE_SWORD))
                .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/ancient_gemstone_weapon");

        // Advancements for Boss Armor Set
        class_8779 bossArmorAdvancement = class_161.class_162.method_707()
                .method_701(enterDimensionAdvancement)
                .method_697(
                        ModItems.BOSS_CROWN,
                        class_2561.method_43470("Full Power of The Villagers"),
                        class_2561.method_43470("Obtain all 4 boss armor pieces"),
                        class_2960.method_60654("textures/gui/advancements/backgrounds/adventure.png"),
                        class_189.field_1254,
                        true,
                        true,
                        true
                )
                .method_705("boss_crown", class_2066.class_2068.method_8959(ModItems.BOSS_CROWN))
                .method_705("boss_chest", class_2066.class_2068.method_8959(ModItems.BOSS_CHESTPLATE))
                .method_705("boss_leggings", class_2066.class_2068.method_8959(ModItems.BOSS_LEGGINGS))
                .method_705("boss_boots", class_2066.class_2068.method_8959(ModItems.BOSS_BOOTS))
                .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/boss_armor");

        // Advancements for Killing Evil Villager
        class_8779 evilVillagerAdvancement = class_161.class_162.method_707()
                .method_701(ancientGemstoneWeaponAdvancement)
                .method_697(
                        ModItems.EVIL_VILLAGER_BOSS_SPAWN_EGG,
                        class_2561.method_43470("Cleanse the village"),
                        class_2561.method_43470("Kill an Evil Villager Boss"),
                        class_2960.method_60654("textures/gui/advancements/backgrounds/adventure.png"),
                        class_189.field_1254,
                        true,
                        true,
                        true)
                .method_705("killed_evil_villager", class_2080.class_2083.method_8997(
                        class_2048.class_2049.method_8916().method_8921(ModEntities.EVIL_VILLAGER_BOSS)))
                .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/killed_evil_pillager");

        // Advancements for Killing Pillager Brute
        class_8779 pillagerBruteAdvancement = class_161.class_162.method_707()
                .method_701(magiciteWeaponAdvancement)
                .method_697(
                        ModItems.PILLAGER_BRUTE_BOSS_SPAWN_EGG,
                        class_2561.method_43470("Free The Contested Lands"),
                        class_2561.method_43470("Kill a Pillager Brute Boss"),
                        class_2960.method_60654("textures/gui/advancements/backgrounds/adventure.png"),
                        class_189.field_1254,
                        true,
                        true,
                        true)
                .method_705("killed_brute_pillager", class_2080.class_2083.method_8997(
                        class_2048.class_2049.method_8916().method_8921(ModEntities.PILLAGER_BRUTE_BOSS)))
                .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/killed_brute_pillager");

        // Advancements for Killing Pillager Wizard
        class_8779 pillagerWizardAdvancement = class_161.class_162.method_707()
                .method_701(pillageriteWeaponAdvancement)
                .method_697(
                        ModItems.PILLAGER_BRUTE_BOSS_SPAWN_EGG,
                        class_2561.method_43470("You Aren't A Wizard Harry"),
                        class_2561.method_43470("Kill a Pillager Wizard Boss"),
                        class_2960.method_60654("textures/gui/advancements/backgrounds/adventure.png"),
                        class_189.field_1254,
                        true,
                        true,
                        true)
                .method_705("killed_wizard_pillager", class_2080.class_2083.method_8997(
                        class_2048.class_2049.method_8916().method_8921(ModEntities.PILLAGER_WIZARD_BOSS)))
                .method_694(consumer, MinecraftVillagerDimensionMod.MOD_ID + "/killed_wizard_pillager");
    }
}
