package net.scott.minecraftvillagerdimensionmod.datagen;

import com.mojang.datafixers.types.templates.Tag;
import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricTagProvider;
import net.minecraft.class_2246;
import net.minecraft.class_2960;
import net.minecraft.class_3481;
import net.minecraft.class_6862;
import net.minecraft.class_7225;
import net.minecraft.class_7924;
import net.scott.minecraftvillagerdimensionmod.block.ModBlocks;
import net.scott.minecraftvillagerdimensionmod.util.ModTags;

import javax.swing.text.html.HTML;
import java.util.concurrent.CompletableFuture;

public class ModBlockTagProvider extends FabricTagProvider.BlockTagProvider {
    public ModBlockTagProvider(FabricDataOutput output, CompletableFuture<class_7225.class_7874> registriesFuture) {
        super(output, registriesFuture);
    }

    @Override
    protected void method_10514(class_7225.class_7874 arg){

        method_10512(class_3481.field_52288)
                .add(ModBlocks.ROWAN_DOOR)
                .add(ModBlocks.JUNIPER_DOOR)
                .add(ModBlocks.SYCAMORE_DOOR);

        // An attempt to fix the wall signs
        method_10512(class_3481.field_40105)
                .add(ModBlocks.HANGING_JUNIPER_SIGN)
                .add(ModBlocks.HANGING_ROWAN_SIGN)
                .add(ModBlocks.HANGING_SYCAMORE_SIGN)
                .add(ModBlocks.WALL_HANGING_JUNIPER_SIGN)
                .add(ModBlocks.WALL_HANGING_ROWAN_SIGN)
                .add(ModBlocks.WALL_HANGING_SYCAMORE_SIGN);

        method_10512(class_3481.field_23210)
                .add(ModBlocks.ROWAN_LOG)
                .add(ModBlocks.STRIPPED_ROWAN_LOG)
                .add(ModBlocks.ROWAN_WOOD)
                .add(ModBlocks.STRIPPED_ROWAN_WOOD)
                .add(ModBlocks.ROWAN_DOOR)
                .add(ModBlocks.ROWAN_TRAPDOOR)
                .add(ModBlocks.ROWAN_BERRY_LEAVES)
                .add(ModBlocks.ROWAN_LEAVES)
                .add(ModBlocks.ROWAN_PLANKS)
                .add(ModBlocks.ROWAN_SLAB)
                .add(ModBlocks.ROWAN_STAIRS)
                .add(ModBlocks.ROWAN_PRESSURE_PLATE)
                .add(ModBlocks.ROWAN_BUTTON)
                .add(ModBlocks.ROWAN_FENCE)
                .add(ModBlocks.ROWAN_FENCE_GATE);

        // New tag for blocks so that the sycamore trunk can grow through
        method_10512(class_6862.method_40092(class_7924.field_41254, class_2960.method_60655("minecraftvillagerdimensionmod", "sycamore_grow_through")))
                .add(class_2246.field_10124)  // Adding air is a typical block trees grow through
                .add(ModBlocks.SYCAMORE_LEAVES);  // Add more blocks as needed

        method_10512(class_3481.field_16584)
                .add(ModBlocks.ROWAN_FENCE);
        method_10512(class_3481.field_25147)
                .add(ModBlocks.ROWAN_FENCE_GATE);
        //*******************************************************************************************************************//


        method_10512(class_3481.field_23210)
                .add(ModBlocks.JUNIPER_LOG)
                .add(ModBlocks.STRIPPED_JUNIPER_LOG)
                .add(ModBlocks.JUNIPER_WOOD)
                .add(ModBlocks.STRIPPED_JUNIPER_WOOD)
                .add(ModBlocks.JUNIPER_DOOR)
                .add(ModBlocks.JUNIPER_TRAPDOOR)
                .add(ModBlocks.JUNIPER_BERRY_LEAVES)
                .add(ModBlocks.JUNIPER_LEAVES)
                .add(ModBlocks.JUNIPER_PLANKS)
                .add(ModBlocks.JUNIPER_SLAB)
                .add(ModBlocks.JUNIPER_STAIRS)
                .add(ModBlocks.JUNIPER_PRESSURE_PLATE)
                .add(ModBlocks.JUNIPER_BUTTON)
                .add(ModBlocks.JUNIPER_FENCE)
                .add(ModBlocks.JUNIPER_FENCE_GATE);

        method_10512(class_3481.field_16584)
                .add(ModBlocks.JUNIPER_FENCE);
        method_10512(class_3481.field_25147)
                .add(ModBlocks.JUNIPER_FENCE_GATE);
        //*******************************************************************************************************************//



        method_10512(class_3481.field_23210)
                .add(ModBlocks.SYCAMORE_LOG)
                .add(ModBlocks.STRIPPED_SYCAMORE_LOG)
                .add(ModBlocks.SYCAMORE_WOOD)
                .add(ModBlocks.STRIPPED_SYCAMORE_WOOD)
                .add(ModBlocks.SYCAMORE_DOOR)
                .add(ModBlocks.SYCAMORE_TRAPDOOR)
                .add(ModBlocks.SYCAMORE_LEAVES)
                .add(ModBlocks.SYCAMORE_PLANKS)
                .add(ModBlocks.SYCAMORE_SLAB)
                .add(ModBlocks.SYCAMORE_STAIRS)
                .add(ModBlocks.SYCAMORE_PRESSURE_PLATE)
                .add(ModBlocks.SYCAMORE_BUTTON)
                .add(ModBlocks.SYCAMORE_FENCE)
                .add(ModBlocks.SYCAMORE_FENCE_GATE);

        method_10512(class_3481.field_16584)
                .add(ModBlocks.SYCAMORE_FENCE);
        method_10512(class_3481.field_25147)
                .add(ModBlocks.SYCAMORE_FENCE_GATE);
        //*******************************************************************************************************************//


        // Since I cant set my tool to be the only one to break, I have to prevent all other tools from breaking this block.
        method_10512(class_3481.field_49930)
                .add(ModBlocks.MAGICITE_BLOCK)
                .add(ModBlocks.MAGICITE_ORE)
                .add(ModBlocks.DEEPSLATE_MAGICITE_ORE)
                .add(ModBlocks.PILLAGERITE_BLOCK)
                .add(ModBlocks.PILLAGERITE_ORE)
                .add(ModBlocks.DEEPSLATE_PILLAGERITE_ORE);
        method_10512(class_3481.field_49928)
                .add(ModBlocks.MAGICITE_BLOCK)
                .add(ModBlocks.MAGICITE_ORE)
                .add(ModBlocks.DEEPSLATE_MAGICITE_ORE)
                .add(ModBlocks.PILLAGERITE_BLOCK)
                .add(ModBlocks.PILLAGERITE_ORE)
                .add(ModBlocks.DEEPSLATE_PILLAGERITE_ORE);
        method_10512(class_3481.field_49927)
                .add(ModBlocks.MAGICITE_BLOCK)
                .add(ModBlocks.MAGICITE_ORE)
                .add(ModBlocks.DEEPSLATE_MAGICITE_ORE)
                .add(ModBlocks.PILLAGERITE_BLOCK)
                .add(ModBlocks.PILLAGERITE_ORE)
                .add(ModBlocks.DEEPSLATE_PILLAGERITE_ORE);
        method_10512(class_3481.field_49929)
                .add(ModBlocks.MAGICITE_BLOCK)
                .add(ModBlocks.MAGICITE_ORE)
                .add(ModBlocks.DEEPSLATE_MAGICITE_ORE)
                .add(ModBlocks.PILLAGERITE_BLOCK)
                .add(ModBlocks.PILLAGERITE_ORE)
                .add(ModBlocks.DEEPSLATE_PILLAGERITE_ORE);
        method_10512(class_3481.field_49926)
                .add(ModBlocks.MAGICITE_BLOCK)
                .add(ModBlocks.MAGICITE_ORE)
                .add(ModBlocks.DEEPSLATE_MAGICITE_ORE)
                .add(ModBlocks.PILLAGERITE_BLOCK)
                .add(ModBlocks.PILLAGERITE_ORE)
                .add(ModBlocks.DEEPSLATE_PILLAGERITE_ORE);
        method_10512(class_3481.field_49925)
                .add(ModBlocks.MAGICITE_BLOCK)
                .add(ModBlocks.MAGICITE_ORE)
                .add(ModBlocks.DEEPSLATE_MAGICITE_ORE)
                .add(ModBlocks.PILLAGERITE_BLOCK)
                .add(ModBlocks.PILLAGERITE_ORE)
                .add(ModBlocks.DEEPSLATE_PILLAGERITE_ORE);

        method_10512(class_3481.field_33717)
                .add(ModBlocks.ANCIENT_GEMSTONE_BLOCK)
                .add(ModBlocks.ANCIENT_GEMSTONE_ORE)
                .add(ModBlocks.DEEPSLATE_ANCIENT_GEMSTONE_ORE);

        method_10512(ModTags.Blocks.NEEDS_ANCIENT_GEMSTONE_TOOL)
                .add(ModBlocks.ANCIENT_GEMSTONE_BLOCK)
                .add(ModBlocks.ANCIENT_GEMSTONE_ORE)
                .add(ModBlocks.DEEPSLATE_ANCIENT_GEMSTONE_ORE);

        method_10512(ModTags.Blocks.INCORRECT_FOR_ANCIENT_GEMSTONE_TOOL)
                .add(ModBlocks.PILLAGERITE_BLOCK)
                .add(ModBlocks.PILLAGERITE_ORE)
                .add(ModBlocks.DEEPSLATE_PILLAGERITE_ORE);

        method_10512(ModTags.Blocks.NEEDS_MAGICITE_TOOL)
                .add(ModBlocks.MAGICITE_BLOCK)
                .add(ModBlocks.MAGICITE_ORE)
                .add(ModBlocks.DEEPSLATE_MAGICITE_ORE);

        method_10512(ModTags.Blocks.NEEDS_PILLAGERITE_TOOL)
                .add(ModBlocks.MAGICITE_BLOCK)
                .add(ModBlocks.MAGICITE_ORE)
                .add(ModBlocks.DEEPSLATE_MAGICITE_ORE)
                .add(ModBlocks.PILLAGERITE_BLOCK)
                .add(ModBlocks.PILLAGERITE_ORE)
                .add(ModBlocks.DEEPSLATE_PILLAGERITE_ORE);
    }
}
