package net.scott.minecraftvillagerdimensionmod.datagen;

import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricModelProvider;
import net.minecraft.class_2960;
import net.minecraft.class_4910;
import net.minecraft.class_4915;
import net.minecraft.class_4942;
import net.minecraft.class_4943;
import net.scott.minecraftvillagerdimensionmod.MinecraftVillagerDimensionMod;
import net.scott.minecraftvillagerdimensionmod.block.ModBlocks;
import net.scott.minecraftvillagerdimensionmod.item.ModItems;

import java.util.Optional;

public class ModModelProvider extends FabricModelProvider {
    public ModModelProvider(FabricDataOutput output) {
        super(output);
    }

    @Override
    public void generateBlockStateModels(class_4910 blockStateModelGenerator) {

        //************************************* ROWAN WOOD ****************************************************************//
        blockStateModelGenerator.method_25676(ModBlocks.ROWAN_LOG).method_25730(ModBlocks.ROWAN_LOG).method_25728(ModBlocks.ROWAN_WOOD);
        blockStateModelGenerator.method_25676(ModBlocks.STRIPPED_ROWAN_LOG).method_25730(ModBlocks.STRIPPED_ROWAN_LOG).method_25728(ModBlocks.STRIPPED_ROWAN_WOOD);
        blockStateModelGenerator.method_25641(ModBlocks.ROWAN_LEAVES);
        blockStateModelGenerator.method_25641(ModBlocks.ROWAN_BERRY_LEAVES);

        class_4910.class_4912 rowan_pool = blockStateModelGenerator.method_25650(ModBlocks.ROWAN_PLANKS);
        rowan_pool.method_33522(ModBlocks.ROWAN_FAMILY);
        rowan_pool.method_25725(ModBlocks.ROWAN_STAIRS);
        rowan_pool.method_25716(ModBlocks.ROWAN_BUTTON);
        rowan_pool.method_25724(ModBlocks.ROWAN_SLAB);
        rowan_pool.method_25723(ModBlocks.ROWAN_PRESSURE_PLATE);
        rowan_pool.method_25721(ModBlocks.ROWAN_FENCE);
        rowan_pool.method_25722(ModBlocks.ROWAN_FENCE_GATE);

        blockStateModelGenerator.method_25658(ModBlocks.ROWAN_DOOR);
        blockStateModelGenerator.method_25671(ModBlocks.ROWAN_TRAPDOOR);

        blockStateModelGenerator.method_25548(ModBlocks.ROWAN_SAPLING, class_4910.class_4913.field_22840);

        //*******************************************************************************************************************//
        //************************************* JUNIPER WOOD ****************************************************************//
        blockStateModelGenerator.method_25676(ModBlocks.JUNIPER_LOG).method_25730(ModBlocks.JUNIPER_LOG).method_25728(ModBlocks.JUNIPER_WOOD);
        blockStateModelGenerator.method_25676(ModBlocks.STRIPPED_JUNIPER_LOG).method_25730(ModBlocks.STRIPPED_JUNIPER_LOG).method_25728(ModBlocks.STRIPPED_JUNIPER_WOOD);
        blockStateModelGenerator.method_25641(ModBlocks.JUNIPER_LEAVES);
        blockStateModelGenerator.method_25641(ModBlocks.JUNIPER_BERRY_LEAVES);

        class_4910.class_4912 juniper_pool = blockStateModelGenerator.method_25650(ModBlocks.JUNIPER_PLANKS);
        juniper_pool.method_33522(ModBlocks.JUNIPER_FAMILY);
        juniper_pool.method_25725(ModBlocks.JUNIPER_STAIRS);
        juniper_pool.method_25716(ModBlocks.JUNIPER_BUTTON);
        juniper_pool.method_25724(ModBlocks.JUNIPER_SLAB);
        juniper_pool.method_25723(ModBlocks.JUNIPER_PRESSURE_PLATE);
        juniper_pool.method_25721(ModBlocks.JUNIPER_FENCE);
        juniper_pool.method_25722(ModBlocks.JUNIPER_FENCE_GATE);

        blockStateModelGenerator.method_25658(ModBlocks.JUNIPER_DOOR);
        blockStateModelGenerator.method_25671(ModBlocks.JUNIPER_TRAPDOOR);

        blockStateModelGenerator.method_25548(ModBlocks.JUNIPER_SAPLING, class_4910.class_4913.field_22840);
        //*******************************************************************************************************************//

        //************************************* SYCAMORE WOOD ****************************************************************//
        blockStateModelGenerator.method_25676(ModBlocks.SYCAMORE_LOG).method_25730(ModBlocks.SYCAMORE_LOG).method_25728(ModBlocks.SYCAMORE_WOOD);
        blockStateModelGenerator.method_25676(ModBlocks.STRIPPED_SYCAMORE_LOG).method_25730(ModBlocks.STRIPPED_SYCAMORE_LOG).method_25728(ModBlocks.STRIPPED_SYCAMORE_WOOD);
        blockStateModelGenerator.method_25641(ModBlocks.SYCAMORE_LEAVES);

        class_4910.class_4912 sycamore_pool = blockStateModelGenerator.method_25650(ModBlocks.SYCAMORE_PLANKS);
        sycamore_pool.method_33522(ModBlocks.SYCAMORE_FAMILY);
        sycamore_pool.method_25725(ModBlocks.SYCAMORE_STAIRS);
        sycamore_pool.method_25716(ModBlocks.SYCAMORE_BUTTON);
        sycamore_pool.method_25724(ModBlocks.SYCAMORE_SLAB);
        sycamore_pool.method_25723(ModBlocks.SYCAMORE_PRESSURE_PLATE);
        sycamore_pool.method_25721(ModBlocks.SYCAMORE_FENCE);
        sycamore_pool.method_25722(ModBlocks.SYCAMORE_FENCE_GATE);

        blockStateModelGenerator.method_25658(ModBlocks.SYCAMORE_DOOR);
        blockStateModelGenerator.method_25671(ModBlocks.SYCAMORE_TRAPDOOR);

        blockStateModelGenerator.method_25548(ModBlocks.SYCAMORE_SAPLING, class_4910.class_4913.field_22840);
        //*******************************************************************************************************************//

        // Block states for hanging signs - Fixes Breaking texture bug
        blockStateModelGenerator.method_46190(
                ModBlocks.STRIPPED_JUNIPER_LOG,      // the log that provides the particle texture
                ModBlocks.HANGING_JUNIPER_SIGN,       // the free-standing hanging sign block
                ModBlocks.WALL_HANGING_JUNIPER_SIGN   // the wall-mounted variant
        );
        blockStateModelGenerator.method_46190(
                ModBlocks.STRIPPED_ROWAN_LOG,
                ModBlocks.HANGING_ROWAN_SIGN,
                ModBlocks.WALL_HANGING_ROWAN_SIGN
        );
        blockStateModelGenerator.method_46190(
                ModBlocks.STRIPPED_SYCAMORE_LOG,
                ModBlocks.HANGING_SYCAMORE_SIGN,
                ModBlocks.WALL_HANGING_SYCAMORE_SIGN
        );
    }

    @Override
    public void generateItemModels(class_4915 itemModelGenerator) {

        // ROWAN WOOD
        //itemModelGenerator.register(ModItems.HANGING_ROWAN_SIGN, Models.GENERATED);

        itemModelGenerator.method_25733(ModItems.ROWAN_BOAT, class_4943.field_22938);
        itemModelGenerator.method_25733(ModItems.ROWAN_CHEST_BOAT, class_4943.field_22938);

        // JUNIPER WOOD
        //itemModelGenerator.register(ModItems.HANGING_JUNIPER_SIGN, Models.GENERATED);

        itemModelGenerator.method_25733(ModItems.JUNIPER_BOAT, class_4943.field_22938);
        itemModelGenerator.method_25733(ModItems.JUNIPER_CHEST_BOAT, class_4943.field_22938);


        // SYCAMORE WOOD
        // Had to remove these because of duplicate definitions?? Minecraft can be weird
        //itemModelGenerator.register(ModItems.HANGING_SYCAMORE_SIGN, Models.GENERATED);

        itemModelGenerator.method_25733(ModItems.SYCAMORE_BOAT, class_4943.field_22938);
        itemModelGenerator.method_25733(ModItems.SYCAMORE_CHEST_BOAT, class_4943.field_22938);

        // ANCIENT GEMSTONE
        itemModelGenerator.method_25733(ModItems.ANCIENT_GEMSTONE_HELMET, class_4943.field_22938);
        itemModelGenerator.method_25733(ModItems.ANCIENT_GEMSTONE_CHESTPLATE, class_4943.field_22938);
        itemModelGenerator.method_25733(ModItems.ANCIENT_GEMSTONE_LEGGINGS, class_4943.field_22938);
        itemModelGenerator.method_25733(ModItems.ANCIENT_GEMSTONE_BOOTS, class_4943.field_22938);


        // PILLAGERITE
        itemModelGenerator.method_25733(ModItems.PILLAGERITE_HELMET, class_4943.field_22938);
        itemModelGenerator.method_25733(ModItems.PILLAGERITE_CHESTPLATE, class_4943.field_22938);
        itemModelGenerator.method_25733(ModItems.PILLAGERITE_LEGGINGS, class_4943.field_22938);
        itemModelGenerator.method_25733(ModItems.PILLAGERITE_BOOTS, class_4943.field_22938);

        // MAGICITE
        itemModelGenerator.method_25733(ModItems.MAGICITE_HELMET, class_4943.field_22938);
        itemModelGenerator.method_25733(ModItems.MAGICITE_CHESTPLATE, class_4943.field_22938);
        itemModelGenerator.method_25733(ModItems.MAGICITE_LEGGINGS, class_4943.field_22938);
        itemModelGenerator.method_25733(ModItems.MAGICITE_BOOTS, class_4943.field_22938);

        // BOSS ARMOR
        itemModelGenerator.method_25733(ModItems.BOSS_CROWN, class_4943.field_22938);
        itemModelGenerator.method_25733(ModItems.BOSS_CHESTPLATE, class_4943.field_22938);
        itemModelGenerator.method_25733(ModItems.BOSS_LEGGINGS, class_4943.field_22938);
        itemModelGenerator.method_25733(ModItems.BOSS_BOOTS, class_4943.field_22938);

        // KOI FISH
        itemModelGenerator.method_25733(ModItems.ORANGE_KOI_FISH_SPAWN_EGG,
                new class_4942(Optional.of(class_2960.method_60654("item/template_spawn_egg")), Optional.empty()));
        itemModelGenerator.method_25733(ModItems.ORANGE_KOI_BUCKET, class_4943.field_22938);

        itemModelGenerator.method_25733(ModItems.WHITE_KOI_FISH_SPAWN_EGG,
                new class_4942(Optional.of(class_2960.method_60654("item/template_spawn_egg")), Optional.empty()));
        itemModelGenerator.method_25733(ModItems.WHITE_KOI_BUCKET, class_4943.field_22938);

        itemModelGenerator.method_25733(ModItems.BLACK_KOI_FISH_SPAWN_EGG,
                new class_4942(Optional.of(class_2960.method_60654("item/template_spawn_egg")), Optional.empty()));
        itemModelGenerator.method_25733(ModItems.BLACK_KOI_BUCKET, class_4943.field_22938);

        // Pillager Brute Boss
        itemModelGenerator.method_25733(ModItems.PILLAGER_BRUTE_BOSS_SPAWN_EGG,
                new class_4942(Optional.of(class_2960.method_60654("item/template_spawn_egg")), Optional.empty()));
        // Evil Villager Boss
        itemModelGenerator.method_25733(ModItems.EVIL_VILLAGER_BOSS_SPAWN_EGG,
                new class_4942(Optional.of(class_2960.method_60654("item/template_spawn_egg")), Optional.empty()));
        // Pillager Wizard Boss
        itemModelGenerator.method_25733(ModItems.PILLAGER_WIZARD_BOSS_SPAWN_EGG,
                new class_4942(Optional.of(class_2960.method_60654("item/template_spawn_egg")), Optional.empty()));

        // Monarch Butterfly
        itemModelGenerator.method_25733(ModItems.MONARCH_BUTTERFLY_SPAWN_EGG,
                new class_4942(Optional.of(class_2960.method_60654("item/template_spawn_egg")), Optional.empty()));

    }
}
