package net.scott.minecraftvillagerdimensionmod.entity.custom;

import net.minecraft.class_1299;
import net.minecraft.class_1347;
import net.minecraft.class_1366;
import net.minecraft.class_1376;
import net.minecraft.class_1400;
import net.minecraft.class_1604;
import net.minecraft.class_1646;
import net.minecraft.class_1657;
import net.minecraft.class_1937;
import net.minecraft.class_2561;
import net.minecraft.class_2960;
import net.minecraft.class_3213;
import net.minecraft.class_3222;
import net.minecraft.class_4291;
import net.minecraft.class_5132;
import net.minecraft.class_5134;
import net.minecraft.class_52;
import net.minecraft.class_5321;
import net.minecraft.class_7924;
import net.minecraft.entity.ai.goal.*;
import net.scott.minecraftvillagerdimensionmod.MinecraftVillagerDimensionMod;
import software.bernie.geckolib.animatable.GeoAnimatable;
import software.bernie.geckolib.animatable.GeoEntity;
import software.bernie.geckolib.animatable.instance.AnimatableInstanceCache;
import software.bernie.geckolib.animatable.instance.SingletonAnimatableInstanceCache;
import software.bernie.geckolib.animation.*;
import java.util.Random;

public class PillagerBruteBossEntity extends class_1604 implements GeoEntity {
    // Special attack chance at 30%
    private static final float SPECIAL_ATTACK_CHANCE = 0.3f; // 30% chance

    // This does not work for loot tables
    public static final class_5321<class_52> LOOT_TABLE_KEY = class_5321.method_29179(
            class_7924.field_50079,
            //RegistryKey.ofRegistry(Identifier.of("minecraft", "loot_table/entities")),
            class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "entities/buffpillager")
    );

    private AnimatableInstanceCache cache = new SingletonAnimatableInstanceCache(this);
    private class_3213 bossBar = null;
    public PillagerBruteBossEntity(class_1299<? extends class_1604> entityType, class_1937 world) {
        super(entityType, world);
        this.bossBar = new class_3213(
                class_2561.method_43470("Gronk The Manly"), // Boss bar title
                class_3213.Color.field_5784,           // Boss bar color
                class_3213.Style.field_5795       // Boss bar style
        );
    }

    public static class_5132.class_5133 createPillagerBruteBossAttributes() {
        return class_1604.method_26828()
                .method_26868(class_5134.field_23716, 250)
                .method_26868(class_5134.field_23719, 0.5f)
                .method_26868(class_5134.field_23724, 3.0f)
                .method_26868(class_5134.field_23721, 15);
    }

    @Override
    protected void method_5959() {
        this.field_6201.method_6277(0, new class_1347(this)); //HAS to be primary goal or entity will drown lol
        this.field_6201.method_6277(1, new class_4291(this, 0.5F, false));
        this.field_6201.method_6277(2, new class_1376(this));
        //this.goalSelector.add(2, new WanderAroundGoal(this, 0.5F, 15));

        //racism is fun - I'm keeping this
        this.field_6185.method_6277(3, new class_1400<>(this, class_1657.class, true));
        this.field_6185.method_6277(4, new class_1400<>(this, class_1646.class, true));
        this.field_6201.method_6277(4, new class_1366(this,0.5F, true));
    }

    @Override
    public void registerControllers(AnimatableManager.ControllerRegistrar controllers) {
        controllers.add(new AnimationController<GeoAnimatable>(this, "controller", 0, this::predicate));
        controllers.add(new AnimationController<GeoAnimatable>(this, "attackcontroller", 0, this::attackpredicate));
    }

    // For attack animation
    private PlayState attackpredicate(AnimationState<GeoAnimatable> tAnimationState) {
        if (this.field_6252 && tAnimationState.getController().getAnimationState().equals(AnimationController.State.STOPPED)) {
            // Check if health is below half
            if (this.method_6032() < this.method_6063() / 2) {
                // Roll for special attack chance
                if (new Random().nextFloat() < SPECIAL_ATTACK_CHANCE) {
                    tAnimationState.getController().forceAnimationReset();
                    tAnimationState.getController().setAnimationSpeed(1.5F); // Adjust speed as needed
                    tAnimationState.getController().setAnimation(RawAnimation.begin().then("jump smash", Animation.LoopType.PLAY_ONCE));
                } else {
                    // Perform basic attack
                    tAnimationState.getController().forceAnimationReset();
                    tAnimationState.getController().setAnimationSpeed(2.0F);
                    tAnimationState.getController().setAnimation(RawAnimation.begin().then("basic attack", Animation.LoopType.PLAY_ONCE));
                }
            } else {
                // Perform basic attack
                tAnimationState.getController().forceAnimationReset();
                tAnimationState.getController().setAnimationSpeed(2.0F);
                tAnimationState.getController().setAnimation(RawAnimation.begin().then("basic attack", Animation.LoopType.PLAY_ONCE));
            }
            this.field_6252 = false;
        }
        return PlayState.CONTINUE;
    }

    @Override
    public boolean method_5974(double distanceSquared) {
        return false; // Prevents natural despawning
    }

    // For basic walk animation
    private PlayState predicate(AnimationState<GeoAnimatable> tAnimationState) {
        if(tAnimationState.isMoving()){
            tAnimationState.getController().setAnimation(RawAnimation.begin().then("walk", Animation.LoopType.LOOP));
            return PlayState.CONTINUE;
        }

        tAnimationState.getController().setAnimation(RawAnimation.begin().then("idle", Animation.LoopType.LOOP));
        return PlayState.CONTINUE;
    }

    @Override
    public AnimatableInstanceCache getAnimatableInstanceCache() {
        return cache;
    }

    // Mostly for the boss bar
    @Override
    public void method_5773() {
        super.method_5773();

        // Update boss bar percentage
        if (!this.method_37908().field_9236 && this.method_5805()) {
            this.bossBar.method_5408(this.method_6032() / this.method_6063());
        }
    }
    // For the boss bar
    @Override
    public void method_5837(class_3222 player) {
        super.method_5837(player);
        this.bossBar.method_14088(player); // Add player to boss bar
    }
    // For the boss bar
    @Override
    public void method_5742(class_3222 player) {
        super.method_5742(player);
        this.bossBar.method_14089(player); // Remove player from boss bar
    }

    @Override
    protected class_5321<class_52> method_5991() {
        return LOOT_TABLE_KEY;
    }
}
