package net.scott.minecraftvillagerdimensionmod.entity.custom;

import net.minecraft.class_1299;
import net.minecraft.class_1309;
import net.minecraft.class_1338;
import net.minecraft.class_1361;
import net.minecraft.class_1366;
import net.minecraft.class_1376;
import net.minecraft.class_1379;
import net.minecraft.class_1400;
import net.minecraft.class_1604;
import net.minecraft.class_1617;
import net.minecraft.class_1646;
import net.minecraft.class_1657;
import net.minecraft.class_1669;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_243;
import net.minecraft.class_2561;
import net.minecraft.class_265;
import net.minecraft.class_2680;
import net.minecraft.class_2960;
import net.minecraft.class_3213;
import net.minecraft.class_3218;
import net.minecraft.class_3222;
import net.minecraft.class_3414;
import net.minecraft.class_3417;
import net.minecraft.class_3532;
import net.minecraft.class_5132;
import net.minecraft.class_5134;
import net.minecraft.class_52;
import net.minecraft.class_5321;
import net.minecraft.class_5712;
import net.minecraft.class_7924;
import net.minecraft.entity.ai.goal.*;
import net.scott.minecraftvillagerdimensionmod.MinecraftVillagerDimensionMod;
import software.bernie.geckolib.animatable.GeoAnimatable;
import software.bernie.geckolib.animatable.GeoEntity;
import software.bernie.geckolib.animatable.instance.AnimatableInstanceCache;
import software.bernie.geckolib.animatable.instance.SingletonAnimatableInstanceCache;
import software.bernie.geckolib.animation.*;

public class PillagerWizardBossEntity extends class_1617 implements GeoEntity {

    // This is for animation
    private AnimatableInstanceCache cache = new SingletonAnimatableInstanceCache(this);

    // This is for the boss bar
    private class_3213 bossBar = null;

    // This data member is for loot tables
    public static final class_5321<class_52> LOOT_TABLE_KEY = class_5321.method_29179(
            class_7924.field_50079,
            class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "entities/wizardpillager")
    );

    // This function is for creating the entity
    public PillagerWizardBossEntity(class_1299<? extends class_1617> entityType, class_1937 world) {
        super(entityType, world);
        this.bossBar = new class_3213(
                class_2561.method_43470("Mortvax The Chaotic"), // Boss bar title
                class_3213.Color.field_5780,           // Boss bar color
                class_3213.Style.field_5795       // Boss bar style
        );
    }

    // This function is also for creating the entity, but this sets his stats
    public static class_5132.class_5133 createPillagerWizardBossAttributes() {
        return class_1604.method_26828()
                .method_26868(class_5134.field_23716, 250)
                .method_26868(class_5134.field_23719, 0.5f)
                .method_26868(class_5134.field_23724, 3.0f)
                .method_26868(class_5134.field_23721, 15);
    }

    // This function is for setting goal priorities and handles how the entity ai behaves
    @Override
    protected void method_5959() {
        // **Target Selection**
        this.field_6185.method_6277(0, new class_1400<>(this, class_1657.class, true));
        this.field_6185.method_6277(1, new class_1400<>(this, class_1646.class, true));

        // **Combat and Spellcasting Priorities**
        this.field_6201.method_6277(2, new ThrowSnowballSpellGoal()); // Prioritize spellcasting
        this.field_6201.method_6277(3, new SummonFangsGoal()); // Special attack when possible
        this.field_6201.method_6277(4, new class_1366(this, 0.6F, true));  // Melee attack if spell is unavailable

        // **Basic Movement and Awareness**
        this.field_6201.method_6277(5, new class_1361(this, class_1657.class, 12.0F));
        this.field_6201.method_6277(6, new class_1376(this));

        // **Tactical Movement (Optional)**
        this.field_6201.method_6277(7, new class_1338<>(this, class_1657.class, 10.0F, 0.5F, 0.8F)); // Runs if low health
        this.field_6201.method_6277(8, new class_1379(this, 0.3F, 20)); // Only wander when idle
    }

    // This is a useless function for this entity. But you have to override from the parent class.
    @Override
    public void method_16484(class_3218 world, int wave, boolean unused) {
        // Do nothing
    }

    // This function is for registering animation controllers, and it dictates what predicate to send an animation instance to.
    @Override
    public void registerControllers(AnimatableManager.ControllerRegistrar controllers) {
        controllers.add(new AnimationController<GeoAnimatable>(this, "controller", 0, this::predicate));
        controllers.add(new AnimationController<GeoAnimatable>(this, "attackcontroller", 0, this::attackpredicate));
    }

    // This function is for handling attack animations
    private PlayState attackpredicate(AnimationState<GeoAnimatable> tAnimationState) {
        class_1617.class_1618 currentSpell = this.method_7140();
        if (this.field_6252) {
            // If target is close enough, use melee attack animation.  -- && currentSpell == SpellcastingIllagerEntity.Spell.NONE
            if (this.method_5968() != null && this.method_5968().method_5858(this) <= 9.0 ) {
                tAnimationState.getController().forceAnimationReset();
                tAnimationState.getController().setAnimationSpeed(2.0F);
                tAnimationState.getController().setAnimation(
                        RawAnimation.begin().then("animation.model.swing", Animation.LoopType.PLAY_ONCE)
                );
            }
            // Otherwise, if a spell is being cast, play its animation.
            if(currentSpell != class_1617.class_1618.field_7377) {
                String animation;
                switch (currentSpell) {
                    case field_7380:
                        animation = "animation.model.chant";
                        break;
                    case field_7379:
                        animation = "animation.model.launch_projectile";
                        break;
                    default:
                        animation = "";
                }
                if (!animation.isEmpty()) {
                    tAnimationState.getController().forceAnimationReset();
                    tAnimationState.getController().setAnimationSpeed(2.0F);
                    tAnimationState.getController().setAnimation(
                            RawAnimation.begin().then(animation, Animation.LoopType.PLAY_ONCE)
                    );
                }
            }
            this.field_6252 = false;
        }
        return PlayState.CONTINUE;
    }

    // Function for basic walk/idle animations
    private PlayState predicate(AnimationState<GeoAnimatable> tAnimationState) {
        if(tAnimationState.isMoving()){
            tAnimationState.getController().setAnimation(RawAnimation.begin().then("animation.model.walk", Animation.LoopType.LOOP));
        }
        else {
            tAnimationState.getController().setAnimation(RawAnimation.begin().then("animation.model.idle", Animation.LoopType.LOOP));
        }
        return PlayState.CONTINUE;
    }

    // This function makes the boss never despawn from the world.
    @Override
    public boolean method_5974(double distanceSquared) {
        return false; // Prevents natural despawning
    }

    // Another useless function that I have to override from parent class.
    @Override
    public class_3414 method_20033() {
        return null;
    }

    // This function is a helper for animations
    @Override
    public AnimatableInstanceCache getAnimatableInstanceCache() {
        return cache;
    }

    // The tick function is mostly for the boss bar, but can be useful for other events.
    @Override
    public void method_5773() {
        super.method_5773();

        // Update boss bar percentage
        if (!this.method_37908().field_9236 && this.method_5805()) {
            this.bossBar.method_5408(this.method_6032() / this.method_6063());
        }
    }

    // This function is for the spell sounds - I use MC's Default
    @Override
    protected class_3414 method_7142() {
        return class_3417.field_14858;
    }

    // This is for the boss bar
    @Override
    public void method_5837(class_3222 player) {
        super.method_5837(player);
        this.bossBar.method_14088(player); // Add player to boss bar
    }
    // This is for the boss bar
    @Override
    public void method_5742(class_3222 player) {
        super.method_5742(player);
        this.bossBar.method_14089(player); // Remove player from boss bar
    }

    // This is for the loot table
    @Override
    protected class_5321<class_52> method_5991() {
        return LOOT_TABLE_KEY;
    }

    //******************************************************************************************************************//
    //                                      Spell Class Definitions
    //******************************************************************************************************************//
    // Cast Fangs
    class SummonFangsGoal extends class_1620 {
        @Override
        protected int method_7149() {
            return 100;
        }

        @Override
        protected int method_7151() {
            return 340;
        }

        @Override
        protected void method_7148() {
            // Set the animation for summoning fangs.
            PillagerWizardBossEntity.this.method_7138(class_1617.class_1618.field_7380);
            class_1309 target = PillagerWizardBossEntity.this.method_5968();
            double d = Math.min(target.method_23318(), PillagerWizardBossEntity.this.method_23318());
            double e = Math.max(target.method_23318(), PillagerWizardBossEntity.this.method_23318()) + 1.0;
            float f = (float) class_3532.method_15349(target.method_23321() - PillagerWizardBossEntity.this.method_23321(), target.method_23317() - PillagerWizardBossEntity.this.method_23317());
            if (PillagerWizardBossEntity.this.method_5858(target) < 9.0) {
                for (int i = 0; i < 5; i++) {
                    float g = f + (float) i * (float) Math.PI * 0.4F;
                    this.conjureFangs(PillagerWizardBossEntity.this.method_23317() + class_3532.method_15362(g) * 1.5,
                            PillagerWizardBossEntity.this.method_23321() + class_3532.method_15374(g) * 1.5, d, e, g, 0);
                }
                for (int i = 0; i < 8; i++) {
                    float g = f + (float) i * (float) Math.PI * 2.0F / 8.0F + (float) (Math.PI * 2.0 / 5.0);
                    this.conjureFangs(PillagerWizardBossEntity.this.method_23317() + class_3532.method_15362(g) * 2.5,
                            PillagerWizardBossEntity.this.method_23321() + class_3532.method_15374(g) * 2.5, d, e, g, 3);
                }
            } else {
                for (int i = 0; i < 16; i++) {
                    double h = 1.25 * (i + 1);
                    int j = i;
                    this.conjureFangs(PillagerWizardBossEntity.this.method_23317() + class_3532.method_15362(f) * h,
                            PillagerWizardBossEntity.this.method_23321() + class_3532.method_15374(f) * h, d, e, f, j);
                }
            }
        }

        private void conjureFangs(double x, double z, double maxY, double y, float yaw, int warmup) {
            class_2338 blockPos = class_2338.method_49637(x, y, z);
            boolean foundSolid = false;
            double offset = 0.0;

            do {
                class_2338 belowPos = blockPos.method_10074();
                class_2680 blockState = PillagerWizardBossEntity.this.method_37908().method_8320(belowPos);
                if (blockState.method_26206(PillagerWizardBossEntity.this.method_37908(), belowPos, class_2350.field_11036)) {
                    if (!PillagerWizardBossEntity.this.method_37908().method_22347(blockPos)) {
                        class_2680 blockState2 = PillagerWizardBossEntity.this.method_37908().method_8320(blockPos);
                        class_265 voxelShape = blockState2.method_26220(PillagerWizardBossEntity.this.method_37908(), blockPos);
                        if (!voxelShape.method_1110()) {
                            offset = voxelShape.method_1105(class_2350.class_2351.field_11052);
                        }
                    }
                    foundSolid = true;
                    break;
                }
                blockPos = blockPos.method_10074();
            } while (blockPos.method_10264() >= class_3532.method_15357(maxY) - 1);

            if (foundSolid) {
                PillagerWizardBossEntity.this.method_37908().method_8649(
                        new class_1669(PillagerWizardBossEntity.this.method_37908(), x, blockPos.method_10264() + offset, z, yaw, warmup, PillagerWizardBossEntity.this)
                );
                PillagerWizardBossEntity.this.method_37908().method_32888(
                        class_5712.field_28738,
                        new class_243(x, blockPos.method_10264() + offset, z),
                        class_5712.class_7397.method_43285(PillagerWizardBossEntity.this)
                );
            }
        }

        @Override
        protected class_3414 method_7150() {
            return class_3417.field_15193;
        }

        @Override
        protected class_1617.class_1618 method_7147() {
            return class_1618.field_7380;
        }
    }

    // Vanilla-like inner class for snowball projectile
    class ThrowSnowballSpellGoal extends class_1620 {
        @Override
        protected int method_7149() {
            return 20; // Duration of the spell casting
        }

        @Override
        protected int method_7151() {
            return 40; // Delay before the spell starts
        }

        @Override
        protected void method_7148() {
            // Set the animation for the snowball throw.
            PillagerWizardBossEntity.this.method_7138(class_1617.class_1618.field_7379);
            class_1309 target = PillagerWizardBossEntity.this.method_5968();
            if (target != null) {
                DamagingSnowballEntity snowball = new DamagingSnowballEntity(PillagerWizardBossEntity.this.method_37908(), PillagerWizardBossEntity.this);
                snowball.method_5814(PillagerWizardBossEntity.this.method_23317(),
                        PillagerWizardBossEntity.this.method_23320() - 0.1,
                        PillagerWizardBossEntity.this.method_23321());

                double dx = target.method_23317() - PillagerWizardBossEntity.this.method_23317();
                double dy = target.method_23323(0.5) - PillagerWizardBossEntity.this.method_23320();
                double dz = target.method_23321() - PillagerWizardBossEntity.this.method_23321();
                float velocity = 1.5F;
                float inaccuracy = 0.0F;
                snowball.method_7485(dx, dy, dz, velocity, inaccuracy);

                PillagerWizardBossEntity.this.method_37908().method_8649(snowball);
            }
        }

        @Override
        protected class_3414 method_7150() {
            return null;
        }

        @Override
        protected class_1617.class_1618 method_7147() {
            // Use an appropriate built-in spell type.
            return class_1618.field_7379;
        }
    }

}