package net.scott.minecraftvillagerdimensionmod.item.custom;

import net.minecraft.class_156;
import net.minecraft.class_1738;
import net.minecraft.class_1741;
import net.minecraft.class_1856;
import net.minecraft.class_2378;
import net.minecraft.class_2960;
import net.minecraft.class_3414;
import net.minecraft.class_3417;
import net.minecraft.class_6880;
import net.minecraft.class_7923;
import net.scott.minecraftvillagerdimensionmod.MinecraftVillagerDimensionMod;
import net.scott.minecraftvillagerdimensionmod.item.ModItems;

import java.util.EnumMap;
import java.util.List;
import java.util.function.Supplier;

public class ModArmorMaterials {

    // ANCIENT GEMSTONE
    public static final class_6880<class_1741> ANCIENT_GEMSTONE_DUST = register("ancient_gemstone_dust", class_156.method_654(new EnumMap(class_1738.class_8051.class), map -> {
        map.put(class_1738.class_8051.field_41937, 4);
        map.put(class_1738.class_8051.field_41936, 7);
        map.put(class_1738.class_8051.field_41935, 9);
        map.put(class_1738.class_8051.field_41934, 4);
        map.put(class_1738.class_8051.field_48838, 12);
    }), 25,
            class_3417.field_21866,
            2.5F,
            0.1F,
            () -> class_1856.method_8091(ModItems.ANCIENT_GEMSTONE_DUST));


    // MAGICITE
    public static final class_6880<class_1741> MAGICITE_DUST = register("magicite_dust", class_156.method_654(new EnumMap(class_1738.class_8051.class), map -> {
                map.put(class_1738.class_8051.field_41937, 5);
                map.put(class_1738.class_8051.field_41936, 8);
                map.put(class_1738.class_8051.field_41935, 10);
                map.put(class_1738.class_8051.field_41934, 5);
                map.put(class_1738.class_8051.field_48838, 13);
            }), 30,
            class_3417.field_21866,
            3.0F,
            0.2F,
            () -> class_1856.method_8091(ModItems.MAGICITE_DUST));


    // PILLAGERITE
    public static final class_6880<class_1741> PILLAGERITE_INGOT = register("pillagerite_ingot", class_156.method_654(new EnumMap(class_1738.class_8051.class), map -> {
                map.put(class_1738.class_8051.field_41937, 6);
                map.put(class_1738.class_8051.field_41936, 9);
                map.put(class_1738.class_8051.field_41935, 11);
                map.put(class_1738.class_8051.field_41934, 6);
                map.put(class_1738.class_8051.field_48838, 14);
            }), 25,
            class_3417.field_21866,
            3.5F,
            0.3F,
            () -> class_1856.method_8091(ModItems.PILLAGERITE_INGOT));

    // BOSS ARMOR
    public static final class_6880<class_1741> BOSS_ARMOR = register("boss_armor", class_156.method_654(new EnumMap<>(class_1738.class_8051.class), map -> {
                map.put(class_1738.class_8051.field_41937, 8);
                map.put(class_1738.class_8051.field_41936, 11);
                map.put(class_1738.class_8051.field_41935, 13);
                map.put(class_1738.class_8051.field_41934, 8);
                map.put(class_1738.class_8051.field_48838, 16);
            }), 30,
            class_3417.field_21866,
            4.5F,
            0.4F,
            class_1856::method_35226); // No repair ingredient

    private static class_6880<class_1741> register(
            String id,
            EnumMap<class_1738.class_8051, Integer> defense,
            int enchantability,
            class_6880<class_3414> equipSound,
            float toughness,
            float knockbackResistance,
            Supplier<class_1856> repairIngredient
    ) {
        List<class_1741.class_9196> list = List.of(new class_1741.class_9196(class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, id)));
        return register(id, defense, enchantability, equipSound, toughness, knockbackResistance, repairIngredient, list);
    }

    private static class_6880<class_1741> register(
            String id,
            EnumMap<class_1738.class_8051, Integer> defense,
            int enchantability,
            class_6880<class_3414> equipSound,
            float toughness,
            float knockbackResistance,
            Supplier<class_1856> repairIngredient,
            List<class_1741.class_9196> layers
    ) {
        EnumMap<class_1738.class_8051, Integer> enumMap = new EnumMap(class_1738.class_8051.class);

        for (class_1738.class_8051 type : class_1738.class_8051.values()) {
            enumMap.put(type, (Integer)defense.get(type));
        }

        return class_2378.method_47985(
                class_7923.field_48976,
                class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, id),
                new class_1741(enumMap, enchantability, equipSound, repairIngredient, layers, toughness, knockbackResistance)
        );
    }

}
