package net.scott.minecraftvillagerdimensionmod.processor;

import com.mojang.serialization.MapCodec;
import net.minecraft.class_2246;
import net.minecraft.class_2338;
import net.minecraft.class_2680;
import net.minecraft.class_3491;
import net.minecraft.class_3492;
import net.minecraft.class_3499;
import net.minecraft.class_3828;
import net.minecraft.class_4538;
import net.scott.minecraftvillagerdimensionmod.MinecraftVillagerDimensionMod;
import org.jetbrains.annotations.Nullable;

public class NoWaterProcessor extends class_3491 {
    public static final MapCodec<NoWaterProcessor> CODEC = MapCodec.unit(NoWaterProcessor::new);

    @Override
    @Nullable
    public class_3499.class_3501 method_15110(
            class_4538 world, class_2338 pos, class_2338 pivot,
            class_3499.class_3501 structureBlockInfo,
            class_3499.class_3501 structureBlockInfo2,
            class_3492 structurePlacementData
    ) {
        class_2338 blockPos = structureBlockInfo2.comp_1341();
        class_2680 blockState = world.method_8320(blockPos);

        // Check if the block is water
        if (blockState.method_27852(class_2246.field_10382)) {
            MinecraftVillagerDimensionMod.LOGGER.info("Water detected at {} - removing structure blocks above", blockPos);

            // Remove this block
            return null;
        }

        // Check if there is water below this block
        class_2338.class_2339 searchPos = blockPos.method_25503();
        while (searchPos.method_10264() > world.method_31607()) {
            searchPos.method_10100(0, -1, 0);
            class_2680 belowState = world.method_8320(searchPos);

            if (belowState.method_27852(class_2246.field_10382)) {
                MinecraftVillagerDimensionMod.LOGGER.info("Block {} is above water - removing", blockPos);
                return null; // Remove this block because it is above water
            }
        }

        // No water found below, keep the block
        return structureBlockInfo2;
    }

    @Override
    protected class_3828<?> method_16772() {
        return MinecraftVillagerDimensionMod.NO_WATER_PROCESSOR;
    }
}