package net.scott.minecraftvillagerdimensionmod.world;

import net.minecraft.class_2960;
import net.minecraft.class_2975;
import net.minecraft.class_3031;
import net.minecraft.class_3037;
import net.minecraft.class_3124;
import net.minecraft.class_3481;
import net.minecraft.class_3798;
import net.minecraft.class_3825;
import net.minecraft.class_4643;
import net.minecraft.class_4649;
import net.minecraft.class_4651;
import net.minecraft.class_5140;
import net.minecraft.class_5204;
import net.minecraft.class_5207;
import net.minecraft.class_5216;
import net.minecraft.class_5321;
import net.minecraft.class_6016;
import net.minecraft.class_6580;
import net.minecraft.class_6796;
import net.minecraft.class_6862;
import net.minecraft.class_7390;
import net.minecraft.class_7871;
import net.minecraft.class_7891;
import net.minecraft.class_7924;
import net.minecraft.world.gen.feature.*;
import net.minecraft.world.gen.foliage.*;
import net.scott.minecraftvillagerdimensionmod.MinecraftVillagerDimensionMod;
import net.scott.minecraftvillagerdimensionmod.block.ModBlocks;

import java.util.Arrays;
import java.util.List;

public class ModConfiguredFeatures {

    // Ore Generation
    public static final class_5321<class_2975<?,?>> ANCIENT_GEMSTONE_ORE_KEY = registerKey("ancient_gemstone_ore");
    public static final class_5321<class_2975<?,?>> MAGICITE_ORE_KEY = registerKey("magicite_ore");
    public static final class_5321<class_2975<?,?>> PILLAGERITE_ORE_KEY = registerKey("pillagerite_ore");

    // Tree Generation
    public static final class_5321<class_2975<?,?>> ROWAN_KEY = registerKey("rowan");
    public static final class_5321<class_2975<?,?>> JUNIPER_KEY = registerKey("juniper");
    public static final class_5321<class_2975<?,?>> SYCAMORE_KEY = registerKey("sycamore");

    public static void bootstrap(class_7891<class_2975<?, ?>> context) {

        // Replaces Ores that are in stone or deepslate
        class_3825 stoneReplacables = new class_3798(class_3481.field_28992);
        class_3825 deepslateReplacables = new class_3798(class_3481.field_28993);

        // Replaces the different ores with the stone or deepslate state
        List<class_3124.class_5876> overworldAncientGemstoneOres =
                List.of(class_3124.method_33994(stoneReplacables, ModBlocks.ANCIENT_GEMSTONE_ORE.method_9564()),
                        class_3124.method_33994(deepslateReplacables, ModBlocks.DEEPSLATE_ANCIENT_GEMSTONE_ORE.method_9564()));
        List<class_3124.class_5876> overworldMagiciteOres =
                List.of(class_3124.method_33994(stoneReplacables, ModBlocks.MAGICITE_ORE.method_9564()),
                        class_3124.method_33994(deepslateReplacables, ModBlocks.DEEPSLATE_MAGICITE_ORE.method_9564()));
        List<class_3124.class_5876> overworldPillageriteOres =
                List.of(class_3124.method_33994(stoneReplacables, ModBlocks.PILLAGERITE_ORE.method_9564()),
                        class_3124.method_33994(deepslateReplacables, ModBlocks.DEEPSLATE_PILLAGERITE_ORE.method_9564()));

        // Change number to make the ores more rare
        register(context, ANCIENT_GEMSTONE_ORE_KEY, class_3031.field_13517, new class_3124(overworldAncientGemstoneOres, 12));
        register(context, MAGICITE_ORE_KEY, class_3031.field_13517, new class_3124(overworldMagiciteOres, 12));
        register(context, PILLAGERITE_ORE_KEY, class_3031.field_13517, new class_3124(overworldPillageriteOres, 12));


        class_7871<class_6796> registryLookup = context.method_46799(class_7924.field_41245);

        class_5216.class_5487 noiseParameters = new class_5216.class_5487(0, 1.0);
        // Rowan Tree Growth
        register(context, ROWAN_KEY, class_3031.field_24134, new class_4643.class_4644(
                class_4651.method_38432(ModBlocks.ROWAN_LOG),
                //This places the trunk. There are lots of different ones
                new class_5140(4,2,1),

                new class_6580(3, noiseParameters, 3, Arrays.asList(
                        ModBlocks.ROWAN_LEAVES.method_9564(),
                        ModBlocks.ROWAN_BERRY_LEAVES.method_9564()
                )),
                // Also several styles of leaves
                // IntProvider radius, IntProvider offset, int height
                new class_5207(class_6016.method_34998(3), class_6016.method_34998(2), 4),

                new class_5204(1,0,2)).method_23445());

        // Rowan Tree Growth
        register(context, JUNIPER_KEY, class_3031.field_24134, new class_4643.class_4644(
                class_4651.method_38432(ModBlocks.JUNIPER_LOG),
                //This places the trunk. There are lots of different ones
                // int baseHeight, int firstRandomHeight, int secondRandomHeight
                new class_5140(2,1,1),

                new class_6580(3, noiseParameters, 3, Arrays.asList(
                        ModBlocks.JUNIPER_LEAVES.method_9564(),
                        ModBlocks.JUNIPER_BERRY_LEAVES.method_9564()
                )),
                // Also several styles of leaves
                // (IntProvider radius, IntProvider offset, IntProvider trunkHeight)
                //new SpruceFoliagePlacer(ConstantIntProvider.create(4), ConstantIntProvider.create(0), ConstantIntProvider.create(3)),
                new class_4649(class_6016.method_34998(3), class_6016.method_34998(1), class_6016.method_34998(3)),

                new class_5204(1,0,2)).method_23445());

        // Rowan Tree Growth
        register(context, SYCAMORE_KEY, class_3031.field_24134, new class_4643.class_4644(
                class_4651.method_38432(ModBlocks.SYCAMORE_LOG),
                //This places the trunk. There are lots of different ones
                // int baseHeight, int firstRandomHeight, int secondRandomHeight
                // int baseHeight,
                // int firstRandomHeight,
                // int secondRandomHeight,
                // IntProvider extraBranchSteps,
                // float placeBranchPerLogProbability,
                // IntProvider extraBranchLength,
                // RegistryEntryList<Block> canGrowThrough
                new class_7390(
                        6,  // baseHeight
                        5,  // firstRandomHeight
                        6,  // secondRandomHeight
                        class_6016.method_34998(5),  // extraBranchSteps
                        0.45f,  // placeBranchPerLogProbability
                        class_6016.method_34998(2),  // extraBranchLength
                        context.method_46799(class_7924.field_41254).method_46735(class_6862.method_40092(class_7924.field_41254, class_2960.method_60655("minecraftvillagerdimensionmod", "sycamore_grow_through")))
                ),

                class_4651.method_38432(ModBlocks.SYCAMORE_LEAVES),
                // Also several styles of leaves
                // (IntProvider radius, IntProvider offset, IntProvider trunkHeight)
                new class_5207(class_6016.method_34998(3), class_6016.method_34998(3),2),
                //new RandomSpreadFoliagePlacer(ConstantIntProvider.create(3), ConstantIntProvider.create(4), ConstantIntProvider.create(3), 40),
                //new BlobFoliagePlacer(ConstantIntProvider.create(3), ConstantIntProvider.create(5),3),

                new class_5204(1, 0, 2)).method_23445());
    }

    // These are needed for the base class of configured feature
    public static class_5321<class_2975<?, ?>> registerKey(String name) {
        return class_5321.method_29179(class_7924.field_41239, class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, name));
    }

    private static <FC extends class_3037, F extends class_3031<FC>> void register(class_7891<class_2975<?, ?>> context,
                                                                                   class_5321<class_2975<?, ?>> key, F feature, FC configuration) {
        context.method_46838(key, new class_2975<>(feature, configuration));
    }
}
