package net.scott.minecraftvillagerdimensionmod.world;

import net.minecraft.class_2960;
import net.minecraft.class_2975;
import net.minecraft.class_5321;
import net.minecraft.class_5843;
import net.minecraft.class_6795;
import net.minecraft.class_6796;
import net.minecraft.class_6797;
import net.minecraft.class_6817;
import net.minecraft.class_6819;
import net.minecraft.class_6880;
import net.minecraft.class_7871;
import net.minecraft.class_7891;
import net.minecraft.class_7924;
import net.scott.minecraftvillagerdimensionmod.MinecraftVillagerDimensionMod;
import net.scott.minecraftvillagerdimensionmod.block.ModBlocks;

import java.util.List;

public class ModPlacedFeatures {

    // Ore Gen Placed Features
    public static final class_5321<class_6796> ANCIENT_GEMSTONE_ORE_PLACED_KEY = registerKey("ancient_gemstone_ore_placed");
    public static final class_5321<class_6796> MAGICITE_ORE_PLACED_KEY = registerKey("magicite_ore_placed");
    public static final class_5321<class_6796> PILLAGERITE_ORE_PLACED_KEY = registerKey("pillagerite_ore_placed");

    // Tree Gen Placed Features
    public static final class_5321<class_6796> ROWAN_TREE_KEY = registerKey("rowan_tree");
    public static final class_5321<class_6796> JUNIPER_TREE_KEY = registerKey("juniper_tree");
    public static final class_5321<class_6796> SYCAMORE_TREE_KEY = registerKey("sycamore_tree");

    public static void bootstrap(class_7891<class_6796> context) {
        class_7871<class_2975<?,?>> registryLookup = context.method_46799(class_7924.field_41239);

        // For ore generation
        register(context, ANCIENT_GEMSTONE_ORE_PLACED_KEY, registryLookup.method_46747(ModConfiguredFeatures.ANCIENT_GEMSTONE_ORE_KEY),
                ModOrePlacement.modifiersWithCount(2, // Veins per chunk
                        class_6795.method_39637(class_5843.method_33841(-20), class_5843.method_33841(10))));
        register(context, MAGICITE_ORE_PLACED_KEY, registryLookup.method_46747(ModConfiguredFeatures.MAGICITE_ORE_KEY),
                ModOrePlacement.modifiersWithCount(3, // Veins per chunk
                        class_6795.method_39637(class_5843.method_33841(-20), class_5843.method_33841(10))));
        register(context, PILLAGERITE_ORE_PLACED_KEY, registryLookup.method_46747(ModConfiguredFeatures.PILLAGERITE_ORE_KEY),
                ModOrePlacement.modifiersWithCount(3, // Veins per chunk
                        class_6795.method_39637(class_5843.method_33841(-20), class_5843.method_33841(10))));

        // For tree generation
        register(context, ROWAN_TREE_KEY, registryLookup.method_46747(ModConfiguredFeatures.ROWAN_KEY),
                class_6819.method_39741(
                        class_6817.method_39736(1, 0.2f, 3),
                        ModBlocks.ROWAN_SAPLING));

        register(context, JUNIPER_TREE_KEY, registryLookup.method_46747(ModConfiguredFeatures.JUNIPER_KEY),
                class_6819.method_39741(
                        class_6817.method_39736(1, 0.2f, 3),
                        ModBlocks.JUNIPER_SAPLING));

        register(context, SYCAMORE_TREE_KEY, registryLookup.method_46747(ModConfiguredFeatures.SYCAMORE_KEY),
                class_6819.method_39741(
                        class_6817.method_39736(1, 0.2f, 3),
                        ModBlocks.SYCAMORE_SAPLING));
    }

    // Base Required Methods
    public static class_5321<class_6796> registerKey(String name) {
        return class_5321.method_29179(class_7924.field_41245, class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, name));
    }

    private static void register(class_7891<class_6796> context, class_5321<class_6796> key, class_6880<class_2975<?, ?>> configuration,
                                 List<class_6797> modifiers) {
        context.method_46838(key, new class_6796(configuration, List.copyOf(modifiers)));
    }
}
